#(# Qsomebase q example SomeBaseType)
#(# Qsomeunit q example SomeUnitType)
#(# Qsomederived q example SomeDerivedType)
 
#(#type $Qsomebase) // Opaque derivation defined in C, presumed a non-unit type
// Used to define an alias for some type from raw C.
// The defining typedef must happen at the C level, e.g.
typedef whatever_t (t $Qsomebase);
 
#(#type $Qsomeunit () ) // Derive from #(t () ), which we treat as a special unit type
 
#(#type $Qsomederived $Qsomenormal ) // Derive from SomeNormalType from before
 
// Opaque derivations:
 
// Alternatively, we might do something dumb like supply an inline typedef and
// allow the preprocessor to "autogenerate" it as needed. That might look like:
#(#type $Qsomebase (typedef "whatever_t" "") )
	// -> typedef whatever_t (t $Qsomebase) ;
// or
#(#type $Qsomebase (typedef "char" "[16]") )
	// -> typedef char #(t $Qsomebase) [16] ;
// or even
#(#type $Qsomebase (typedef "int (*" ")(const void*,const void*)") )
	// -> typedef int (*#(t $Qsomebase))(const void*,const void*) ;
// I believe, however, that there are strong arguments against doing it that
// way--it's too flexible to be simple and not flexible enough to be useful. It
// could be stretched a bit using treenames to complete the concept:
#(#type $Qsomebase (ctype whatever_t) )
#(#type $Qsomebase (carray char 16) )
#(#type $Qsomebase (cfuncp int (cptr void (const) ) (cptr void (const) ) ) )
// We also might simply indicate what header we'll need to define the type;
// e.g.
#(#type $Qsomebase (include "somelib/example.SomeBaseType.h") )
// All subject to future discussion.
